require 'quick_benchmark/version'
require 'quick_benchmark/fixnum'
require 'benchmark'

module QuickBenchmark
    
  TimeTest = Struct.new :label, :method
  
  def benchmark(iterations = 100, &tests)
    @tests = []
    tests.call
    iterations = QuickBenchmark.iterations_given(iterations)
    Benchmark.bmbm(7) do |x|
      @tests.each do |test|
        x.report(test.label) do
          iterations.times { test.method }
        end
      end
    end
  end
  
  def self.iterations_given(amount)
    if amount.respond_to? :count
      amount.count
    else
      amount
    end
  end
  
  def time(label, &method)
    t = TimeTest.new label.to_s, method
    @tests.push t
  end
    
end

include QuickBenchmark